Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc	(revision 1315)
@@ -37,15 +37,23 @@
 //
 //      Modifications:
+//        15 April 1999, Alessandro Brunengo (Alessandro.Brunengo@ge.infn.it)
+//              Added creation time evaluation for products of evaporation
+//
+//        21 Nov. 2001, Fan Lei (flei@space.qinetiq.com)
+//              i) added G4int _nucleusZ initialise it through the constructor
+//              ii) modified SelectGamma() to allow the generation of conversion electrons    
+//              iii) added #include G4AtomicShells.hh
+//      
 //        09 Sep. 2002, Fan Lei  (flei@space.qinetiq.com)
 //              Added renormalization to determine whether transition leads to
 //              electron or gamma in SelectGamma()
 //
-//        21 Nov. 2001, Fan Lei (flei@space.qinetiq.com)
-//              i) added G4int _nucleusZ initialise it through the constructor
-//              ii) modified SelectGamma() to allow the generation of conversion electrons      
-//              iii) added #include G4AtomicShells.hh
-//      
-//        15 April 1999, Alessandro Brunengo (Alessandro.Brunengo@ge.infn.it)
-//              Added creation time evaluation for products of evaporation
+//        19 April 2010, J. M. Quesada. 
+//              Corrections added for taking into account mismatch between tabulated 
+//              gamma energies and level energy differences (fake photons eliminated) 
+//
+//        9 May 2010, V.Ivanchenko
+//              Removed unphysical corretions of gamma energy; fixed default particle 
+//              as gamma; do not subtract bounding energy in case of electron emmision
 //      
 // -------------------------------------------------------------------
@@ -55,4 +63,7 @@
 #include "G4RandGeneralTmp.hh"
 #include "G4AtomicShells.hh"
+//JMQ: 
+#include "G4NuclearLevelStore.hh"
+#include "G4Pow.hh"
 
 G4DiscreteGammaTransition::G4DiscreteGammaTransition(const G4NuclearLevel& level): 
@@ -60,9 +71,13 @@
 { }
 
-G4DiscreteGammaTransition::G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z): 
+//JMQ: now A is also needed in the constructor
+//G4DiscreteGammaTransition::G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z): 
+G4DiscreteGammaTransition::G4DiscreteGammaTransition(const G4NuclearLevel& level, G4int Z, G4int A): 
   _nucleusZ(Z), _orbitE(-1), _bondE(0.), _aGamma(true), _icm(false), _gammaEnergy(0.), 
-  _level(level), _excitation(0.),  _gammaCreationTime(0.)
+  _level(level), _excitation(0.),  _gammaCreationTime(0.),_A(A),_Z(Z)
 {
   _verbose = 0;
+  //JMQ: added tolerence in the mismatch
+  _tolerance = CLHEP::keV;
 }
 
@@ -74,27 +89,44 @@
 void G4DiscreteGammaTransition::SelectGamma()
 {
-
+  // default gamma 
+  _aGamma = true;    
   _gammaEnergy = 0.;
-
+  
   G4int nGammas = _level.NumberOfGammas();
   if (nGammas > 0)
     {
       G4double random = G4UniformRand();
-
-      G4int iGamma = 0;
-      for(iGamma=0;iGamma < nGammas;iGamma++)
+      
+      G4int iGamma;
+      for(iGamma=0; iGamma<nGammas; ++iGamma)
 	{
 	  if(random <= (_level.GammaCumulativeProbabilities())[iGamma])
-	    break;
+	    { break; }
 	}
-
-
+      
       // Small correction due to the fact that there are mismatches between 
       // nominal level energies and emitted gamma energies
-
-      G4double eCorrection = _level.Energy() - _excitation;
-
+      
+      // 09.05.2010 VI : it is an error ?
+      G4double eCorrection = _level.Energy() - _excitation;      
       _gammaEnergy = (_level.GammaEnergies())[iGamma] - eCorrection;
-
+            
+      //JMQ: 
+      //1)If chosen gamma energy is close enough to excitation energy, the later
+      //  is used instead for gamma dacey to gs (it guarantees energy conservation)
+      //2)For energy conservation, level energy differences instead of  tabulated 
+      //  gamma energies must be used (origin of final fake photons)
+      
+      if(_excitation - _gammaEnergy < _tolerance)      
+	{ 
+	  _gammaEnergy =_excitation;
+	}
+      else
+	{		 
+	  _levelManager = G4NuclearLevelStore::GetInstance()->GetManager(_Z,_A);
+	  _gammaEnergy = _excitation - 
+	    _levelManager->NearestLevel(_excitation - _gammaEnergy)->Energy();
+	}
+      
       //  Warning: the following check is needed to avoid loops:
       //  Due essentially to missing nuclear levels in data files, it is
@@ -106,6 +138,10 @@
       //          but this change needs a more complex revision of actual design.
       //          I leave this for a later revision.
-
-      if (_gammaEnergy < _level.Energy()*10e-5) _gammaEnergy = _excitation;
+      
+      if (_gammaEnergy < _level.Energy()*10.e-5) _gammaEnergy = _excitation;
+
+      //G4cout << "G4DiscreteGammaTransition::SelectGamma: " << _gammaEnergy 
+      //	     << " _icm: " << _icm << G4endl;
+
       // now decide whether Internal Coversion electron should be emitted instead
       if (_icm) {
@@ -144,20 +180,31 @@
 	      }
 	    }
-	    if (_verbose > 0)
+	    _bondE = G4AtomicShells::GetBindingEnergy(_nucleusZ, iShell);
+	    if (_verbose > 0) {
 	      G4cout << "G4DiscreteGammaTransition: _nucleusZ = " <<_nucleusZ 
 		     << " , iShell = " << iShell  
-		     << " , Shell binding energy = " << G4AtomicShells::GetBindingEnergy(_nucleusZ, iShell) / keV
+		     << " , Shell binding energy = " << _bondE/keV
 		     << " keV " << G4endl;
-	    _bondE = G4AtomicShells::GetBindingEnergy(_nucleusZ, iShell);
-	    _gammaEnergy = _gammaEnergy - _bondE;
+	    }
+
+	    // 09.05.2010 VI : it is an error - cannot subtract bond energy from 
+	    //                 transition energy here
+	    //_gammaEnergy = _gammaEnergy - _bondE; 
+	    //G4cout << "_gammaEnergy = " << _gammaEnergy << G4endl;
+
 	    _orbitE = iShell;	  
 	    _aGamma = false ;   // emitted is not a gamma now 
 	  }
       }
-    
-      G4double tau = _level.HalfLife() / std::log(2.0);
-
-      G4double tMin = 0;
-      G4double tMax = 10.0 * tau;
+      
+      G4double tau = _level.HalfLife() / G4Pow::GetInstance()->logZ(2);
+
+      //09.05.2010 VI rewrite samling of decay time 
+      //              assuming ordinary exponential low
+      _gammaCreationTime = 0.;      
+      if(tau > 0.0) {  _gammaCreationTime = -tau*log(G4UniformRand()); }
+
+      //G4double tMin = 0;
+      //G4double tMax = 10.0 * tau;
       //  Original code, not very efficent
       //  G4int nBins = 200;
@@ -172,9 +219,10 @@
       //  G4RandGeneralTmp randGeneral(sampleArray, nBins);
       //G4double random = randGeneral.shoot();
-  
+      
       //_gammaCreationTime = tMin + (tMax - tMin) * random;
 
       // new code by Fan Lei
       //
+      /*
       if (tau != 0 ) 
       {
@@ -186,15 +234,9 @@
 	  //	   << _gammaCreationTime/second << G4endl;
        } else { _gammaCreationTime=0.; }
+      */
     }
   return;
 }
 
-
-//G4bool G4DiscreteGammaTransition::IsAGamma()
-//{
-//  return _aGamma;
-//}
-
-
 G4double G4DiscreteGammaTransition::GetGammaEnergy()
 {
@@ -210,10 +252,9 @@
 {
   _excitation = energy;
-  return;
-}
-
-
-
-
-
-
+}
+
+
+
+
+
+
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc	(revision 1315)
@@ -25,42 +25,37 @@
 //
 //
-//  Class G4E1Probability.cc
+// $Id: G4E1Probability.cc,v 1.9 2010/05/25 10:47:24 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+//
+//---------------------------------------------------------------------
+//
+// Geant4 class G4E1Probability
+//
+// by V. Lara (May 2003)
+//
+// Modifications:
+// 18.05.2010 V.Ivanchenko trying to speedup the most slow method
+//            by usage of G4Pow, integer A and introduction of const members
+//
 //
 
 #include "G4E1Probability.hh"
-#include "G4ConstantLevelDensityParameter.hh"
+//#include "G4ConstantLevelDensityParameter.hh"
 #include "Randomize.hh"
+#include "G4Pow.hh"
 
 // Constructors and operators
 //
 
-G4E1Probability::G4E1Probability(const G4E1Probability& ) : G4VEmissionProbability()
-{
-
-  throw G4HadronicException(__FILE__, __LINE__, "G4E1Probability::copy_constructor meant to not be accessible");
-
-}
-
-const G4E1Probability& G4E1Probability::
-operator=(const G4E1Probability& ) 
-{
-
-  throw G4HadronicException(__FILE__, __LINE__, "G4E1Probability::operator= meant to not be accessible");
-  return *this;
-}
-
-G4bool G4E1Probability::operator==(const G4E1Probability& ) const
-{
-
-  return false;
-
-}
-
-G4bool G4E1Probability::operator!=(const G4E1Probability& ) const
-{
-
-  return true;
-
-}
+G4E1Probability::G4E1Probability():G4VEmissionProbability()
+{
+  G4double x = CLHEP::pi*CLHEP::hbarc;
+  normC = 1.0 / (x*x);
+  theLevelDensityParameter = 0.125/MeV;
+  fG4pow = G4Pow::GetInstance(); 
+}
+
+G4E1Probability::~G4E1Probability()
+{}
 
 // Calculate the emission probability
@@ -68,5 +63,5 @@
 
 G4double G4E1Probability::EmissionProbDensity(const G4Fragment& frag, 
-                                                 const G4double gammaE)
+					      const G4double gammaE)
 {
 
@@ -76,14 +71,12 @@
   // the probability density for photon evaporation from U to U - gammaE
   // (U = nucleus excitation energy, gammaE = total evaporated photon
-  // energy).
-  // fragment = nuclear fragment BEFORE de-excitation
+  // energy). Fragment = nuclear fragment BEFORE de-excitation
 
   G4double theProb = 0.0;
 
-  const G4double Afrag = frag.GetA();
-  const G4double Zfrag = frag.GetZ();
-  const G4double Uexcite = frag.GetExcitationEnergy();
-
-  if( (Uexcite-gammaE) < 0.0 || gammaE < 0 || Uexcite <= 0) return theProb;
+  G4int Afrag = frag.GetA_asInt();
+  G4double Uexcite = frag.GetExcitationEnergy();
+
+  if( (Uexcite-gammaE) < 0.0 || gammaE < 0) { return theProb; }
 
   // Need a level density parameter.
@@ -91,13 +84,14 @@
   // nuclei).
 
-  static G4ConstantLevelDensityParameter a;
-
-  G4double aLevelDensityParam = a.LevelDensityParameter(static_cast<G4int>(Afrag),
-							static_cast<G4int>(Zfrag),
-							Uexcite);
-
-  G4double levelDensBef = std::exp(2.0*std::sqrt(aLevelDensityParam*Uexcite));
-  G4double levelDensAft = std::exp(2.0*std::sqrt(aLevelDensityParam*(Uexcite-gammaE)));
-
+  G4double aLevelDensityParam = Afrag*theLevelDensityParameter;
+
+  //  G4double levelDensBef = std::exp(2*std::sqrt(aLevelDensityParam*Uexcite));
+  //  G4double levelDensAft = std::exp(2*std::sqrt(aLevelDensityParam*(Uexcite-gammaE)));
+  // VI reduce number of calls to exp 
+  G4double levelDens = 1.0;
+  if( aLevelDensityParam > 0.0 ) {
+    levelDens = std::exp(2*(std::sqrt(aLevelDensityParam*(Uexcite-gammaE)) 
+      - std::sqrt(aLevelDensityParam*Uexcite))); 
+  }
   // Now form the probability density
 
@@ -107,9 +101,7 @@
   G4double sigma0 = 2.5 * Afrag * millibarn;  // millibarns
 
-  G4double Egdp = (40.3 / std::pow(Afrag,0.2) )*MeV;
+  G4double Egdp   = (40.3 / fG4pow->powZ(Afrag,0.2) )*MeV;
   G4double GammaR = 0.30 * Egdp;
  
-  static G4double normC = 1.0 / ((pi * hbarc)*(pi * hbarc));
-
   // CD
   //cout<<"  PROB TESTS "<<G4endl;
@@ -124,12 +116,18 @@
   //cout<<" normC = "<<normC<<G4endl;
 
-  G4double numerator = sigma0 * gammaE*gammaE * GammaR*GammaR;
-  G4double denominator = (gammaE*gammaE - Egdp*Egdp)*
-           (gammaE*gammaE - Egdp*Egdp) + GammaR*GammaR*gammaE*gammaE;
-
-  G4double sigmaAbs = numerator/denominator; 
-
-  theProb = normC * sigmaAbs * gammaE*gammaE *
-            levelDensAft/levelDensBef;
+  // VI implementation 18.05.2010
+  G4double gammaE2 = gammaE*gammaE;
+  G4double gammaR2 = gammaE2*GammaR*GammaR;
+  G4double egdp2   = gammaE2 - Egdp*Egdp;
+  G4double sigmaAbs = sigma0*gammaR2/(egdp2*egdp2 + gammaR2); 
+  theProb = normC * sigmaAbs * gammaE2 * levelDens;
+
+  // old implementation
+  //  G4double numerator = sigma0 * gammaE*gammaE * GammaR*GammaR;
+  // G4double denominator = (gammaE*gammaE - Egdp*Egdp)*
+  //         (gammaE*gammaE - Egdp*Egdp) + GammaR*GammaR*gammaE*gammaE;
+
+  //G4double sigmaAbs = numerator/denominator; 
+  //theProb = normC * sigmaAbs * gammaE2 * levelDensAft/levelDensBef;
 
   // CD
@@ -211,5 +209,3 @@
 }
 
-G4E1Probability::~G4E1Probability() {}
-
-
+
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4PhotonEvaporation.cc	(revision 1315)
@@ -24,5 +24,6 @@
 // ********************************************************************
 //
-
+// $Id: G4PhotonEvaporation.cc,v 1.13 2010/05/17 11:47:43 flei Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -37,7 +38,7 @@
 //      Creation date: 23 October 1998
 //
-//      Modifications: 
+// Modifications: 
 //      
-//        8 March 2002, Fan Lei (flei@space.qinetiq.com)
+// 8 March 2002, Fan Lei (flei@space.qinetiq.com)
 //   
 //        Implementation of Internal Convertion process in discrete deexcitation
@@ -50,5 +51,9 @@
 //       G4ElectronOccupancy GetEOccupancy () ;
 //
+// 11 May 2010, V.Ivanchenko add implementation of EmittedFragment and 
+//                           BreakUpFragment methods; cleanup logic
+//
 // -------------------------------------------------------------------
+//
 
 #include "G4PhotonEvaporation.hh"
@@ -86,17 +91,103 @@
 void G4PhotonEvaporation::Initialize(const G4Fragment& fragment)
 {
-  _nucleus = fragment;
-  return;
-}
-
+  _nucleus = const_cast<G4Fragment*>(&fragment);
+}
+
+G4Fragment* G4PhotonEvaporation::EmittedFragment(G4Fragment* nucleus)
+{
+  //G4cout << "G4PhotonEvaporation::EmittedFragment" << G4endl;
+  _nucleus = nucleus;
+  
+  // Do one photon emission by the continues deexcitation  
+  _contDeexcitation->SetNucleus(_nucleus);
+  _contDeexcitation->Initialize();
+
+  if(_contDeexcitation->CanDoTransition()) {  
+    G4Fragment* gamma = _contDeexcitation->GenerateGamma();
+    if(gamma) { 
+      if (_verbose > 0) {
+	G4cout << "G4PhotonEvaporation::EmittedFragment continium deex: "   
+	       << gamma << G4endl;
+        G4cout << "   Residual: " << nucleus << G4endl;
+      }
+      return gamma; 
+    }
+  }
+
+  // Do one photon emission by the discrete deexcitation 
+  _discrDeexcitation->SetNucleus(_nucleus);
+  _discrDeexcitation->Initialize();
+
+  if(_discrDeexcitation->CanDoTransition()) {  
+    G4Fragment* gamma = _discrDeexcitation->GenerateGamma();
+    if(gamma) { 
+      if (_verbose > 0) {
+	G4cout << "G4PhotonEvaporation::EmittedFragment discrete deex: "   
+	       << gamma << G4endl;
+        G4cout << "   Residual: " << nucleus << G4endl;
+      }
+      return gamma; 
+    }
+  }
+
+  if (_verbose > 0) {
+    G4cout << "G4PhotonEvaporation unable emit gamma: " 
+	   << nucleus << G4endl;
+  }
+  return 0;
+}
+
+G4FragmentVector* G4PhotonEvaporation::BreakUpFragment(G4Fragment* nucleus)
+{
+  //G4cout << "G4PhotonEvaporation::BreakUpFragment" << G4endl;
+  // The same pointer of primary nucleus
+  _nucleus = nucleus;
+  _contDeexcitation->SetNucleus(_nucleus);
+  _discrDeexcitation->SetNucleus(_nucleus);
+
+  // Do the whole gamma chain 
+  G4FragmentVector* products = _contDeexcitation->DoChain();  
+  if( !products ) { products = new G4FragmentVector(); }
+
+  if (_verbose > 0) {
+    G4cout << "G4PhotonEvaporation::BreakUpFragment " << products->size() 
+	   << " gammas from ContinuumDeexcitation " << G4endl;
+    G4cout << "   Residual: " << nucleus << G4endl;
+  }
+  // Products from discrete gamma transitions
+  G4FragmentVector* discrProducts = _discrDeexcitation->DoChain();
+  if(discrProducts) {
+    _eOccupancy = _discrDeexcitation->GetEO();
+    _vShellNumber = _discrDeexcitation->GetVacantSN();
+
+    // not sure if the following line is needed!
+    _discrDeexcitation->SetVaccantSN(-1);
+
+    if (_verbose > 0) {
+      G4cout << "G4PhotonEvaporation::BreakUpFragment " << discrProducts->size() 
+	     << " gammas from DiscreteDeexcitation " << G4endl;
+      G4cout << "   Residual: " << nucleus << G4endl;
+    }
+    G4FragmentVector::iterator i;
+    for (i = discrProducts->begin(); i != discrProducts->end(); ++i)
+      {
+	products->push_back(*i);
+      }
+    delete discrProducts;
+  }
+
+  if (_verbose > 0) {
+    G4cout << "*-*-* Photon evaporation: " << products->size() << G4endl;
+  }
+  return products;
+}
 
 G4FragmentVector* G4PhotonEvaporation::BreakUp(const G4Fragment& nucleus)
 {
-  _nucleus = nucleus;
-
-  G4FragmentVector* products = new G4FragmentVector;
- 
-  _contDeexcitation->SetNucleus(nucleus);
-  _discrDeexcitation->SetNucleus(nucleus);
+  //G4cout << "G4PhotonEvaporation::BreakUp" << G4endl;
+  _nucleus = new G4Fragment(nucleus);
+
+  _contDeexcitation->SetNucleus(_nucleus);
+  _discrDeexcitation->SetNucleus(_nucleus);
   
   // Do one photon emission
@@ -104,130 +195,94 @@
   // Products from continuum gamma transitions
 
-  G4FragmentVector* contProducts = _contDeexcitation->DoTransition();  
-
-  G4int nCont = 0;
-  if (contProducts != 0) nCont = contProducts->size();
-
-  G4FragmentVector::iterator i;
-  if (nCont > 0)
-    {
-      G4Fragment modifiedNucleus = _contDeexcitation->GetNucleus();
-      _discrDeexcitation->SetNucleus(modifiedNucleus);
-      for (i = contProducts->begin(); i != contProducts->end(); i++)
-	{
-	  products->push_back(*i);
-	}
-    }
-  else
+  G4FragmentVector* products = _contDeexcitation->DoTransition();  
+  if( !products ) { products = new G4FragmentVector(); }
+  else if(_verbose > 0) {
+    G4cout << "G4PhotonEvaporation::BreakUp " << products->size() 
+	   << " gammas from ContinuesDeexcitation " << G4endl;
+    G4cout << "   Residual: " << nucleus << G4endl;
+  }
+
+  if (0 == products->size())
     {
       // Products from discrete gamma transitions
       G4FragmentVector* discrProducts = _discrDeexcitation->DoTransition();
-      
-      G4int nDiscr = 0;
-      if (discrProducts != 0) nDiscr = discrProducts->size();
-      
-      if (_verbose > 0)
-	G4cout << " = BreakUp = " << nDiscr 
-	       << " gammas from DiscreteDeexcitation " 
-	       << G4endl;
-      
-      for (i = discrProducts->begin(); i != discrProducts->end(); i++)
-	{
-	  products->push_back(*i);
+
+      if (discrProducts) {
+	_eOccupancy = _discrDeexcitation->GetEO();
+	_vShellNumber = _discrDeexcitation->GetVacantSN();
+
+	// not sure if the following line is needed!
+	_discrDeexcitation->SetVaccantSN(-1);
+	//
+	if (_verbose > 0) {
+	  G4cout << " = BreakUp = " << discrProducts->size() 
+		 << " gammas from DiscreteDeexcitation " 
+		 << G4endl;
+	  G4cout << "   Residual: " << nucleus << G4endl;
 	}
-      discrProducts->clear();
-      delete discrProducts;
+	G4FragmentVector::iterator i;
+	for (i = discrProducts->begin(); i != discrProducts->end(); ++i)
+	  {
+	    products->push_back(*i);
+	  }
+	delete discrProducts;
+      }
     }
-
-
-  _gammaE = 0.;
-  if (products->size() > 0)
-    {
-      _gammaE = (*(products->begin()))->GetMomentum().e();
-    }
-
-  contProducts->clear();
-  delete contProducts;  // delete vector, not fragments 
-
+  
   // Add deexcited nucleus to products
-  G4Fragment* finalNucleus = new G4Fragment(_discrDeexcitation->GetNucleus());
-  products->push_back(finalNucleus);
-
-
-  if (_verbose > 0)
+  products->push_back(_nucleus);
+
+  if (_verbose > 0) {
     G4cout << "*-*-*-* Photon evaporation: " << products->size() << G4endl;
+  }
 
   return products;
 }
 
-
 G4FragmentVector* G4PhotonEvaporation::BreakItUp(const G4Fragment& nucleus)
 {
-  _nucleus = nucleus;
-
-  G4FragmentVector* products = new G4FragmentVector;
-
-  _contDeexcitation->SetNucleus(nucleus);
-  _discrDeexcitation->SetNucleus(nucleus);
+  // The same pointer of primary nucleus
+  _nucleus = new G4Fragment(nucleus);
+  _contDeexcitation->SetNucleus(_nucleus);
+  _discrDeexcitation->SetNucleus(_nucleus);
+
+  //G4cout << "G4PhotonEvaporation::BreakItUp:  " << nucleus << G4endl;
 
   // Do the whole gamma chain 
-
-  G4FragmentVector* contProducts = _contDeexcitation->DoChain();  
+  G4FragmentVector* products = _contDeexcitation->DoChain();  
+  if( !products ) { products = new G4FragmentVector; }
 
   // Products from continuum gamma transitions
-  G4int nCont = 0;
-  if (contProducts != 0) nCont = contProducts->size();
-
-  if (_verbose > 0)
-    G4cout << " = BreakItUp = " << nCont 
+  if (_verbose > 0) {
+    G4cout << " = BreakItUp = " << products->size()
 	   << " gammas from ContinuumDeexcitation " << G4endl;
-
-  G4FragmentVector::iterator i;
-  if (nCont > 0)
-    {
-      G4Fragment modifiedNucleus = _contDeexcitation->GetNucleus();
-      _discrDeexcitation->SetNucleus(modifiedNucleus);
-      for (i = contProducts->begin(); i != contProducts->end(); i++)
-	{
-	  products->push_back(*i);
-	}
-    }
+  }
 
   // Products from discrete gamma transitions
   G4FragmentVector* discrProducts = _discrDeexcitation->DoChain();
-  _eOccupancy = _discrDeexcitation->GetEO();
-  _vShellNumber = _discrDeexcitation->GetVacantSN();
-
-  // not sure if the following line is needed!
-  _discrDeexcitation->SetVaccantSN(-1);
-
-  G4int nDiscr = 0;
-  if (discrProducts != 0) nDiscr = discrProducts->size();
-
-  if (_verbose > 0)
-    G4cout << " = BreakItUp = " << nDiscr 
-	   << " gammas from DiscreteDeexcitation " << G4endl;
-
-  for (i = discrProducts->begin(); i != discrProducts->end(); i++)
-    {
-      products->push_back(*i);
+  if(discrProducts) {
+    _eOccupancy = _discrDeexcitation->GetEO();
+    _vShellNumber = _discrDeexcitation->GetVacantSN();
+
+    // not sure if the following line is needed!
+    _discrDeexcitation->SetVaccantSN(-1);
+
+    if (_verbose > 0) {
+      G4cout << " = BreakItUp = " << discrProducts->size() 
+	     << " gammas from DiscreteDeexcitation " << G4endl;
     }
-
+    G4FragmentVector::iterator i;
+    for (i = discrProducts->begin(); i != discrProducts->end(); ++i)
+      {
+	products->push_back(*i);
+      }
+    delete discrProducts;
+  }
   // Add deexcited nucleus to products
-  G4Fragment* finalNucleus = new G4Fragment(_discrDeexcitation->GetNucleus());
-  products->push_back(finalNucleus);
-  if (_verbose > 0)
-    G4cout << " = BreakItUp = Nucleus added to products" << G4endl;
-
-  if (_verbose > 0)
+  products->push_back(_nucleus);
+
+  if (_verbose > 0) {
     G4cout << "*-*-* Photon evaporation: " << products->size() << G4endl;
-
-#ifdef debug
-  CheckConservation(nucleus,products);
-#endif
-  contProducts->clear();
-  discrProducts->clear();
-  delete contProducts;  // delete vector, not fragments 
-  delete discrProducts;
+  }
   return products;
 }
@@ -236,5 +291,7 @@
 {
   G4double prob = 0.;
-  if (_probAlgorithm != 0) prob = _probAlgorithm->EmissionProbability(_nucleus,_gammaE);
+  if (_probAlgorithm != 0) {
+    prob = _probAlgorithm->EmissionProbability(*_nucleus,_gammaE);
+  }
   return prob;
 }
